import { FunctionParams } from '@kubb/react';
import { Operation } from '@kubb/oas';
import { OperationSchemas } from '@kubb/plugin-oas';
import { ReactNode } from 'react';
import { P as PluginSolidQuery, T as Transformer } from './types-BXsh-RxZ.cjs';
import '@kubb/core';

type Props$2 = {
    /**
     * Name of the function
     */
    name: string;
    queryOptionsName: string;
    queryKeyName: string;
    queryKeyTypeName: string;
    typeSchemas: OperationSchemas;
    operation: Operation;
    paramsCasing: PluginSolidQuery['resolvedOptions']['paramsCasing'];
    paramsType: PluginSolidQuery['resolvedOptions']['paramsType'];
    pathParamsType: PluginSolidQuery['resolvedOptions']['pathParamsType'];
    dataReturnType: PluginSolidQuery['resolvedOptions']['client']['dataReturnType'];
};
type GetParamsProps$2 = {
    paramsCasing: PluginSolidQuery['resolvedOptions']['paramsCasing'];
    paramsType: PluginSolidQuery['resolvedOptions']['paramsType'];
    pathParamsType: PluginSolidQuery['resolvedOptions']['pathParamsType'];
    dataReturnType: PluginSolidQuery['resolvedOptions']['client']['dataReturnType'];
    typeSchemas: OperationSchemas;
};
declare function Query({ name, queryKeyTypeName, queryOptionsName, queryKeyName, paramsCasing, paramsType, pathParamsType, dataReturnType, typeSchemas, operation, }: Props$2): ReactNode;
declare namespace Query {
    var getParams: ({ paramsType, paramsCasing, pathParamsType, dataReturnType, typeSchemas }: GetParamsProps$2) => FunctionParams;
}

type Props$1 = {
    name: string;
    typeName: string;
    typeSchemas: OperationSchemas;
    operation: Operation;
    paramsCasing: PluginSolidQuery['resolvedOptions']['paramsCasing'];
    pathParamsType: PluginSolidQuery['resolvedOptions']['pathParamsType'];
    transformer: Transformer | undefined;
};
type GetParamsProps$1 = {
    paramsCasing: PluginSolidQuery['resolvedOptions']['paramsCasing'];
    pathParamsType: PluginSolidQuery['resolvedOptions']['pathParamsType'];
    typeSchemas: OperationSchemas;
};
declare function QueryKey({ name, typeSchemas, paramsCasing, pathParamsType, operation, typeName, transformer }: Props$1): ReactNode;
declare namespace QueryKey {
    var getParams: ({ pathParamsType, paramsCasing, typeSchemas }: GetParamsProps$1) => FunctionParams;
    var getTransformer: Transformer;
}

type Props = {
    name: string;
    clientName: string;
    queryKeyName: string;
    typeSchemas: OperationSchemas;
    paramsCasing: PluginSolidQuery['resolvedOptions']['paramsCasing'];
    paramsType: PluginSolidQuery['resolvedOptions']['paramsType'];
    pathParamsType: PluginSolidQuery['resolvedOptions']['pathParamsType'];
    dataReturnType: PluginSolidQuery['resolvedOptions']['client']['dataReturnType'];
};
type GetParamsProps = {
    paramsCasing: PluginSolidQuery['resolvedOptions']['paramsCasing'];
    paramsType: PluginSolidQuery['resolvedOptions']['paramsType'];
    pathParamsType: PluginSolidQuery['resolvedOptions']['pathParamsType'];
    typeSchemas: OperationSchemas;
};
declare function QueryOptions({ name, clientName, typeSchemas, paramsCasing, paramsType, dataReturnType, pathParamsType, queryKeyName }: Props): ReactNode;
declare namespace QueryOptions {
    var getParams: ({ paramsType, paramsCasing, pathParamsType, typeSchemas }: GetParamsProps) => FunctionParams;
}

export { Query, QueryKey, QueryOptions };
